/* 
  AUTOGENERATED FILE
  Do not manually edit
  Run "npm run generateARMClients" to regenerate
*/

import * as Types from "./types";

/* Lists all the restorable Azure Cosmos DB database accounts available under the subscription and in a region. */
export async function listByLocation(
  subscriptionId: string,
  location: string
): Promise<Types.RestorableDatabaseAccountsListResult | Types.ErrorResponseUpdatedFormat> {
  const path = `/subscriptions/${subscriptionId}/providers/Microsoft.DocumentDB/locations/${location}/restorableDatabaseAccounts`;
  return window.fetch(path, { method: "get" }).then(response => response.json());
}

/* Lists all the restorable Azure Cosmos DB database accounts available under the subscription. */
export async function list(
  subscriptionId: string
): Promise<Types.RestorableDatabaseAccountsListResult | Types.ErrorResponseUpdatedFormat> {
  const path = `/subscriptions/${subscriptionId}/providers/Microsoft.DocumentDB/restorableDatabaseAccounts`;
  return window.fetch(path, { method: "get" }).then(response => response.json());
}

/* Retrieves the properties of an existing Azure Cosmos DB restorable database account. */
export async function getByLocation(
  subscriptionId: string,
  location: string,
  instanceId: string
): Promise<Types.RestorableDatabaseAccountGetResult | Types.ErrorResponseUpdatedFormat> {
  const path = `/subscriptions/${subscriptionId}/providers/Microsoft.DocumentDB/locations/${location}/restorableDatabaseAccounts/${instanceId}`;
  return window.fetch(path, { method: "get" }).then(response => response.json());
}
